How to run emili
================

Install the emili framework following the instructions on the [GitHub repository](https://github.com/federicoPagnozzi/emili) and make sure you are on the ```sa``` branch.

Run emili as

```
./emili instance problem algorithm parameters
```

For example, in our case we use the algorithm ```SA```, and we can instantiate a FTA for example as

```
./emili Ta120.txt PFSP_MS SA nehff insert RANDOMWALKAVGINITTEMP 10000 0.0637 METROPOLIS NOCOOLING SANOTEMPRESTART NEVERTERM NOTEMPLEN SARANDOMEXPLORATION
```

The full list of components is available in the supplementary material and grammar files.

How to configure and design a SA algorithm using irace
======================================================

We refer to the official [```irace```](https://iridia.ulb.ac.be/irace/) documentation
for instructions on how to tune a general algorithm.

We provide some basic template files to perform a full configuration/design.
All the paths in the files need to be set correctly, according to the local installation.
In the ```target-runner``` set also the desired runtime.
In the grammar file, select the desired fixed parts, such as the problem and the problem-specific components.
If needed, generate a new ```parameters.txt``` file ussing the ```grammar2code``` script:
```
grammar2code grammar.xml -p parameters.txt
```
Provide the correct list of training instances in the ```instances.txt``` file.
In the ```scenario.txt``` set the correct parameters for the desired tuning setup.
Finally, launch ```irace```. The final configuration will be the one that can be used on the test set of instances.

